#include <bits/stdc++.h>

using namespace std;

using ll = long long;
vector<set<int>>cnt;
vector<int>visited;
vector<int>path;
vector<vector<int>>g;
vector<int>road;

void dfs(int v){
    visited[v] = 1;
    for (int i = 0; i < g[v].size(); ++i) {
        if (visited[g[v][i]]==0){
            path[g[v][i]] = path[v]+1;
            cnt[path[g[v][i]]].insert(g[v][i]);
            road[g[v][i]] = v;
            dfs(g[v][i]);
        }
    }
}

int safe = 0;

void upd(int v,int cn){
    cn--;
    if (cn==0){
        cnt[path[v]].erase(v);
        path[v] = 1;
        cnt[path[v]].insert(v);
        road[v] = 0;
        safe = v;
        return;
    }else{
        upd(road[v],cn);
    }
}

void upd1(int v){
    for (int i = 0; i < g[v].size(); ++i) {
        if (path[g[v][i]]>path[v]+1){
            cnt[path[g[v][i]]].erase(g[v][i]);
            path[g[v][i]] = path[v]+1;
            cnt[path[g[v][i]]].insert(g[v][i]);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n,k,t;
    cin>>n>>k>>t;
    cnt.resize(n);
    visited.resize(n);
    g.resize(n);
    path.resize(n);
    road.resize(n);
    for (int i = 0; i < n-1; ++i) {
        int x,y;
        cin>>x>>y;
        x--,y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    if (t==0){
        int ans = 0;
        dfs(0);
        for (int i = cnt.size()-1; i >=0 ; --i) {
            for(auto it : cnt[i]){
                if (k==0){
                    break;
                }
                int h = (path[it]+1)/2;
                upd(it,h);
                upd1(safe);
                k--;
            }
            if (cnt[i].size()>0){
                ans = max(ans,i);
            }
        }
        cout<<ans;
    }
    return 0;
}