#include <bits/stdc++.h>

using namespace std;
using ll = long long;

bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
    return a.first + a.second < b.first + b.second;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> a(n);
    vector<pair<ll, ll>> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        b[i].first = a[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
        b[i].first = a[i].second;
    }
    sort(b.begin(), b.end(), cmp);
    ll ans = 0;
    ll l = 0;
    ll r = LONG_LONG_MAX;
    while (l + 1 < r) {
        ll md = (l + r) / 2;
        ll sum = 0;
        for (int i = 0; i < n; ++i) {
            if (md - a[i].first - a[i].second + 1>=35){
                sum = LONG_LONG_MAX;
                break;
            }
            if (md >= a[i].first + a[i].second - 1) {
                sum += (1 << (md - a[i].first - a[i].second + 1));
            } else if (md >= a[i].first) {
                sum++;
            }
            if (sum > m) {
                break;
            }
        }
        if (sum >= m) {
            r = md;
            if (sum==m) {
                ans = sum;
            }
        } else if (sum < m) {
            l = md;
        }
    }
    if (ans==m){
        cout<<r;
    }else{
        cout<<-1;
    }
    return 0;
}